# remirepo/Fedora spec file for php-zendframework-zendservice-recaptcha
#
# Copyright (c) 2015-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    b21625c54f19ba5be5c90ab9fa167ca075cd1594
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   ZendService_ReCaptcha
%global pk_project   zendservice-recaptcha
%global php_home     %{_datadir}/php
%global namespace    ZendService
%global library      ReCaptcha
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{gh_owner}-%{pk_project}
Version:        3.2.0
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://framework.zend.com/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-json
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-autoloader(%{gh_owner}/zend-http)           >= 2.5.4 with php-autoloader(%{gh_owner}/zend-http)           < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-json)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1 with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# From composer.json, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.5",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-config": "^2.0",
#        "zendframework/zend-validator": "^2.8.2"
BuildRequires: (php-autoloader(%{gh_owner}/zend-config)         >= 2.0   with php-autoloader(%{gh_owner}/zend-config)         < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-validator)      >= 2.8.2 with php-autoloader(%{gh_owner}/zend-validator)      < 3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.5
# remirepo:14
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-http)           <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-http)           >= 2.5.4
BuildRequires:  php-autoloader(%{gh_owner}/zend-json)           <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-config)         <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-config)         >= 2.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      >= 2.8.2
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit6 >= 6.5.8
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-http": "^2.5.4",
#        "zendframework/zend-json": "^2.6.1 || ^3.0",
#        "zendframework/zend-stdlib": "^3.2.1"
Requires:       php(language) >= 5.6
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-http)           >= 2.5.4 with php-autoloader(%{gh_owner}/zend-http)           < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-json)           < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1 with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# remirepo:8
%else
Requires:       php-autoloader(%{gh_owner}/zend-http)           <  3
Requires:       php-autoloader(%{gh_owner}/zend-http)           >= 2.5.4
Requires:       php-autoloader(%{gh_owner}/zend-json)           <  4
Requires:       php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 3.2.1
%endif
# From compsoer, "suggest": {
#        "zendframework/zend-validator": "~2.0, if using ReCaptcha's Mailhide API"
Suggests:       php-autoloader(%{gh_owner}/zend-validator)
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 3.0.0 (mcrypt is optional)
Requires:       php-json

Provides:       php-composer(%{gh_owner}/%{pk_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{pk_project}) = %{version}


%description
%{summary}.


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Generate autoloader for this framework extension - deprecated
cat << 'EOF' | tee autoload.php
<?php
Zend\Loader\AutoloaderFactory::factory(array(
    'Zend\Loader\StandardAutoloader' => array(
        'namespaces' => array(
            '%{namespace}\\%{library}' => dirname(__DIR__) . '/%{namespace}/%{library}',
))));
EOF

: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Http/autoload.php',
    '%{php_home}/Zend/Json/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Validator/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/%{namespace}
cp -pr src %{buildroot}%{php_home}/%{namespace}/%{library}

install -Dpm 644 autoload.php %{buildroot}%{php_home}/Zend/%{namespace}-%{library}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/%{namespace}/%{library}/autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Config/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendServiceTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --exclude online --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%dir %{php_home}/%{namespace}
     %{php_home}/%{namespace}/%{library}
     %{php_home}/Zend/%{namespace}-%{library}-autoload.php


%changelog
* Fri Feb  8 2019 Remi Collet <remi@remirepo.net> - 3.2.0-1
- update to 3.2.0
- add dependency on zend-stdlib 3.2.1

* Mon May 14 2018 Remi Collet <remi@remirepo.net> - 3.1.0-2
- update to 3.1.0
- use range dependencies on F27+
- switch to phpunit6 or phpunit7

* Mon Dec 11 2017 Remi Collet <remi@remirepo.net> - 3.0.0-6
- fix virtual provide

* Sat Dec  9 2017 Remi Collet <remi@remirepo.net> - 3.0.0-5
- switch from zend-loader to fedora/autoloader

* Thu Mar  2 2017 Remi Collet <remi@fedoraproject.org> - 3.0.0-3
- add patch to skip online tests, from
  https://github.com/zendframework/ZendService_ReCaptcha/pull/12

* Fri Feb 24 2017 Remi Collet <remi@fedoraproject.org> - 3.0.0-2
- rewrite autoloader as framework extension

* Mon Feb 20 2017 Remi Collet <remi@fedoraproject.org> - 3.0.0-1
- update to 3.0.0

* Thu Aug  6 2015 Remi Collet <remi@fedoraproject.org> - 2.0.1-1
- initial package
